#include "art/Framework/Principal/Event.h"
#include "art/Framework/Principal/Handle.h"
#include "art/Framework/Principal/Run.h"
#include "art/Framework/Principal/SubRun.h"
#include "art/Utilities/InputTag.h"
#include "fhiclcpp/ParameterSet.h"
#include "art/Framework/Services/Registry/ActivityRegistry.h"
#include "art/Framework/Services/Registry/ServiceMacros.h"

#include "SuperNovaDDT/SNMessageInterface.h"

#include "DAQMessages/ccpp_NSNMessages.h"
#include "DAQMessages/DDSMailbox.hpp"

#include "SuperNovaDDT/online/MessageBuffer.h"

// A service to send data 
namespace  novaddt{

    class SNMessageService: public SNMessageInterface{
        public:
            SNMessageService(fhicl::ParameterSet const& p, art::ActivityRegistry& reg);
            void PushPoint(uint64_t time, uint64_t hits) override;
        private:
            DDSOutbox<nsnmessages::NSNPackedMessage> fMailbox;
            MessageBuffer fMessageBuffer;
    };

}
DECLARE_ART_SERVICE_INTERFACE_IMPL(novaddt::SNMessageService,novaddt::SNMessageInterface,LEGACY);
